# I3DShParamInfo Struct Reference
[Shell Interfaces]

Inheritance diagram for I3DShParamInfo:

List of all members.

## Public Member Functions
virtual void *MCCOMAPI | GetLeafParam () const =0
virtual IDType MCCOMAPI | GetType () const =0
virtual IDType MCCOMAPI | GetID () const =0
virtual const int8 *MCCOMAPI | GetName () const =0
virtual void MCCOMAPI | GetParamValue (TParamHolder &param) const =0
virtual void MCCOMAPI | SetParamValue (const TParamHolder &param)=0
virtual MCCOMErr MCCOMAPI | GetGroupParam (ITimeBased **outGroupParam) const =0
virtual I3DShTimeBasedData *MCCOMAPI | GetGroupParamDataNoAddRef () const =0
virtual MCCOMErr MCCOMAPI | GetFather (I3DShTimeBasedData **outFather) const =0
virtual I3DShTimeBasedData *MCCOMAPI | GetFatherNoAddRef () const =0
virtual int32 MCCOMAPI | GetIndexInFather () const =0
virtual boolean MCCOMAPI | IsEnabled () const =0
virtual boolean MCCOMAPI | IsValid () const =0
virtual boolean MCCOMAPI | IsGroup () const =0
virtual boolean MCCOMAPI | IsValidGroup () const =0
virtual MCCOMErr MCCOMAPI | SetGroupParam (ITimeBased *inGroupParam)=0
virtual MCCOMErr MCCOMAPI | SetEnable (boolean inEnabled)=0
virtual TMCPoint MCCOMAPI | GetDrawOrigin ()=0
virtual void MCCOMAPI | SetDrawOrigin (TMCPoint &origin)=0
virtual void MCCOMAPI | SetShowGraph (boolean shown)=0
virtual boolean MCCOMAPI | GetShowGraph ()=0
virtual int32 MCCOMAPI | GetGraphColorIndex () const =0
virtual int32 MCCOMAPI | GetParamTimeLineCount () const =0
virtual int32 MCCOMAPI | AddParamTimeLine (uint32 id)=0
virtual void MCCOMAPI | RemoveParamTimeLine (int32 index)=0
virtual int32 MCCOMAPI | FindParamTimeLine (uint32 id) const =0
virtual I3DShParamTimeLine *MCCOMAPI | GetParamTimeLine (int32 index=0) const =0
virtual uint32 MCCOMAPI | GetParamTimeLineID (int32 index) const =0
| Returns the unique id of one of the additional time line.
virtual I3DShParamTimeLine *MCCOMAPI | GetActiveParamTimeLine () const =0
virtual void MCCOMAPI | Invalidate ()=0
virtual MCCOMErr MCCOMAPI | MarkParamAsModified (boolean createKeyframe=true)=0
| Mark a parameter as invalid. Create a keyframe if needed.
virtual void MCCOMAPI | CheckParamForRead ()=0

## Detailed Description

I3DShParamInfo is implemented by Animated Parameters. Each animated object (see ITimeBased) has a list of animated parameters (see I3DShTimeBasedData). This interface gives access to the attributes of the parameter as well as its keyframes.

## Member Function Documentation

virtual int32 MCCOMAPI I3DShParamInfo::AddParamTimeLine | ( | uint32 | id | ) | `[pure virtual]`

You can add time lines to a param using this function. Every additional time line is identified by a id that should be unique.

Parameters:

  | id | The unique id for this time line.

virtual void MCCOMAPI I3DShParamInfo::CheckParamForRead | ( |  | ) | `[pure virtual]`

Should be called before accessing the value of an animated parameter.

See also:
  I3DShTimeBasedData::CheckParamForRead()

virtual int32 MCCOMAPI I3DShParamInfo::FindParamTimeLine | ( | uint32 | id | ) | const`[pure virtual]`

Finds the time line index given an id. This function goes thought all the additional time lines and search for the one that has the correct id. It returns -1 if the time line is not found.

Parameters:

  | id | The unique id for the time line.

virtual I3DShParamTimeLine* MCCOMAPI I3DShParamInfo::GetActiveParamTimeLine | ( |  | ) | const`[pure virtual]`

Returns a pointer to the active time line. The active time line is one of the param time lines depending on the current animation edit mode.

virtual TMCPoint MCCOMAPI I3DShParamInfo::GetDrawOrigin | ( |  | ) | `[pure virtual]`

Internal use only.

virtual MCCOMErr MCCOMAPI I3DShParamInfo::GetFather | ( | I3DShTimeBasedData ** | outFather | ) | const`[pure virtual]`

Returns a pointer to the parent of this parameter.

Parameters:

  | outFather | A pointer to the parent of this parameter.

virtual I3DShTimeBasedData* MCCOMAPI I3DShParamInfo::GetFatherNoAddRef | ( |  | ) | const`[pure virtual]`

Returns a pointer to the parent of this parameter.

virtual int32 MCCOMAPI I3DShParamInfo::GetGraphColorIndex | ( |  | ) | const`[pure virtual]`

Returns the index of the color to be used in the graph editor (-1 means default color).

virtual MCCOMErr MCCOMAPI I3DShParamInfo::GetGroupParam | ( | ITimeBased ** | outGroupParam | ) | const`[pure virtual]`

You can use this function to get a pointer to the sub parameter of this parameter. (use IsGroup() to see if it has sub parameters).

Parameters:

  | outGroupParam | A pointer to the group of sub parameters.

virtual I3DShTimeBasedData* MCCOMAPI I3DShParamInfo::GetGroupParamDataNoAddRef | ( |  | ) | const`[pure virtual]`

You can use this function to get a pointer to the sub parameter of this parameter. (use IsGroup() to see if it has sub parameters).

virtual IDType MCCOMAPI I3DShParamInfo::GetID | ( |  | ) | const`[pure virtual]`

Returns the ID of the parameter (if the parameter is in the parameter map of a component, then it is the ID of the parameter in the Pmap).

virtual int32 MCCOMAPI I3DShParamInfo::GetIndexInFather | ( |  | ) | const`[pure virtual]`

Returns the index of the parameter in the father time based data.

virtual void* MCCOMAPI I3DShParamInfo::GetLeafParam | ( |  | ) | const`[pure virtual]`

virtual const int8* MCCOMAPI I3DShParamInfo::GetName | ( |  | ) | const`[pure virtual]`

Returns the name of the parameter.

virtual I3DShParamTimeLine* MCCOMAPI I3DShParamInfo::GetParamTimeLine | ( | int32 | index = `0` | ) | const`[pure virtual]`

Returns a pointer to the time line. The time line is the list of all the keyframes and tweeners that defines that value of this parameter over time. Note that a param can have multiple time lines.

Parameters:

  | index | Index if the time line if the param have multiple time lines. 0 means the default time line.

virtual int32 MCCOMAPI I3DShParamInfo::GetParamTimeLineCount | ( |  | ) | const`[pure virtual]`

Returns the number of time lines this param has.

virtual uint32 MCCOMAPI I3DShParamInfo::GetParamTimeLineID | ( | int32 | index | ) | const`[pure virtual]`

Returns the unique id of one of the additional time line.

Parameters:

  | index | Index if the time line.

virtual void MCCOMAPI I3DShParamInfo::GetParamValue | ( | TParamHolder & | param | ) | const`[pure virtual]`

Get the value of the parameter.

Parameters:

  | param | the result (must be of the correct type)

virtual boolean MCCOMAPI I3DShParamInfo::GetShowGraph | ( |  | ) | `[pure virtual]`

Internal use only.

virtual IDType MCCOMAPI I3DShParamInfo::GetType | ( |  | ) | const`[pure virtual]`

Returns the type of the parameter. (see PMapTypes.h for a list of types)

virtual void MCCOMAPI I3DShParamInfo::Invalidate | ( |  | ) | `[pure virtual]`

Invalidates the param that will be recomputed by the next CheckParamForRead().

virtual boolean MCCOMAPI I3DShParamInfo::IsEnabled | ( |  | ) | const`[pure virtual]`

Returns true if the parameter is enabled.

virtual boolean MCCOMAPI I3DShParamInfo::IsGroup | ( |  | ) | const`[pure virtual]`

Returns true if the parameter is a group of parameters (see GetGroupParamDataNoAddRef()).

virtual boolean MCCOMAPI I3DShParamInfo::IsValid | ( |  | ) | const`[pure virtual]`

Returns true if the parameted is valid.

virtual boolean MCCOMAPI I3DShParamInfo::IsValidGroup | ( |  | ) | const`[pure virtual]`

virtual MCCOMErr MCCOMAPI I3DShParamInfo::MarkParamAsModified | ( | boolean | createKeyframe = `true` | ) | `[pure virtual]`

Mark a parameter as invalid. Create a keyframe if needed.

Parameters:

  | createKeyframe | Should create a keyframe.

See also:
  I3DShTimeBasedData::MarkParamAsModified()

virtual void MCCOMAPI I3DShParamInfo::RemoveParamTimeLine | ( | int32 | index | ) | `[pure virtual]`

Removes one of the time line. Note that this function can only remove additional time lines.

Parameters:

  | index | Index of the time line to be removed.

virtual void MCCOMAPI I3DShParamInfo::SetDrawOrigin | ( | TMCPoint & | origin | ) | `[pure virtual]`

Internal use only.

virtual MCCOMErr MCCOMAPI I3DShParamInfo::SetEnable | ( | boolean | inEnabled | ) | `[pure virtual]`

Enables this parameter.

virtual MCCOMErr MCCOMAPI I3DShParamInfo::SetGroupParam | ( | ITimeBased * | inGroupParam | ) | `[pure virtual]`

Sets the pointer to the group of sub parameters of this parameter.

Parameters:

  | inGroupParam | A pointer to the group of sub parameters of this parameter.

virtual void MCCOMAPI I3DShParamInfo::SetParamValue | ( | const TParamHolder & | param | ) | `[pure virtual]`

Set the value of the parameter.

Parameters:

  | param | the result (must be of the correct type)

virtual void MCCOMAPI I3DShParamInfo::SetShowGraph | ( | boolean | shown | ) | `[pure virtual]`

Internal use only.

The documentation for this struct was generated from the following file:

- I3dShAnimation.h